<?php

namespace app\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use app\models\Usuario;

/**
 * UsuarioSearch represents the model behind the search form of `app\models\Usuario`.
 */
class UsuarioSearch extends Usuario
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'per_pk'], 'integer'],
            [['usr_pk', 'usr_nombre', 'usr_pwd', 'usr_login', 'usr_estado', 'rol_id', 'api_key', 'perfilName'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Usuario::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'per_pk' => $this->per_pk,
        ]);

        $query->andFilterWhere(['!=', 'per_pk', 3]);        

        $query->andFilterWhere(['like', 'usr_pk', $this->usr_pk])
            ->andFilterWhere(['like', 'usr_nombre', $this->usr_nombre])
            ->andFilterWhere(['like', 'usr_pwd', $this->usr_pwd])
            ->andFilterWhere(['like', 'usr_login', $this->usr_login])
            ->andFilterWhere(['like', 'usr_estado', $this->usr_estado])
            ->andFilterWhere(['like', 'rol_id', $this->rol_id])
            ->andFilterWhere(['like', 'api_key', $this->api_key])
            ->andFilterWhere(['like', 'perfilName', $this->perfilName]);

        return $dataProvider;
    }
}
